local addon, env = ...
local pool_followers	   = {}
local pool_followers_troop = {}
local pool_followers_xp = {}
local pool_followers_updated = nil
local mission_success = {}

env.mission_success = mission_success


local function table_k(t, value)
	for k, v in next, t do
		if ( v == value ) then
			return k
		end
	end
	return nil
end

local function table_in_table(t1,t2)
	for k, v  in next, t1 do
		if not table_k(t2, v) then
			return nil
		end
	end
	return 1
end

local function compare_table(t1, t2)
	return table_in_table(t1, t2) and table_in_table(t2, t1)
end

local function GetPoolFollowers(t, store)
	local followerlist = C_Garrison.GetFollowers(LE_FOLLOWER_TYPE_GARRISON_7_0) or {}
	wipe(t)
	for i = 1, #followerlist do
		local follower = followerlist[i]
		if ( follower.isCollected and ( not follower.status or follower.status == GARRISON_FOLLOWER_IN_PARTY ) ) then
			if store then
				pool_followers_troop[follower.followerID] = follower.isTroop
				pool_followers_xp[follower.followerID] = not follower.isTroop and (follower.levelXP >0) 
				if follower.isTroop then
				
					table.insert(t, follower.followerID)

					--table.insert(t, 1, follower.followerID)
				else
					table.insert(t, follower.followerID)
					--print(follower.name)
				end
			else
				table.insert(t, follower.followerID)
			end
		end
	end
	return t
end

--[[
local wt = {}
local function isPoolFollowersUP2DATE()
	local t = GetPoolFollowers(wt)
	if table_in_table(t, pool_followers) and  table_in_table(pool_followers, t) then
		return 1
	else
		return nil --GetFollowersPool(pool_followers)
	end

end
]]

local function updateme()
	env.update_MissionList(OrderHallMissionFrame.MissionTab.MissionList)
end

local function UpdateMission()
	pool_followers_updated = nil
	C_Timer.After(1, updateme)
end
local frame = CreateFrame("Frame")
frame:RegisterEvent("GARRISON_FOLLOWER_UPGRADED")
frame:RegisterEvent("GARRISON_FOLLOWER_XP_CHANGED")
frame:RegisterEvent("GARRISON_FOLLOWER_REMOVED")
frame:RegisterEvent("GARRISON_FOLLOWER_LIST_UPDATE")


frame:SetScript("OnEvent", function()
	pool_followers_updated = nil
end)

OrderHallMissionFrame.MissionTab.MissionList.CombatAllyUI.InProgress.Unassign:HookScript("OnClick", UpdateMission)
OrderHallMissionFrame.MissionTab.ZoneSupportMissionPage.StartMissionButton:HookScript("OnClick", UpdateMission)


--RegisterEvent(function(...) print("pwet", ...) end, "GARRISON_MISSION_STARTED", "GARRISON_MISSION_FINISHED", "GARRISON_MISSION_COMPLETE_RESPONSE")
	

local function save(n, combi, mission, i, successChance, cost, xp, totalTimeSeconds, n_xp)
	local info = mission_success[mission.missionID][i] or {}
	
	info.n = n
	info.successChance = successChance
	info.totalTimeSeconds = totalTimeSeconds
	info.cost = cost
	info.xp =  xp
	info.n_xp =n_xp
 	for j=1,n do
		info[j] = pool_followers[combi[j]]
	end
	mission_success[mission.missionID][i] = info
	
end

local function rule_selection(n,combi, mission, xp, n_xp)

	local totalTimeString, totalTimeSeconds, isMissionTimeImproved, successChance, partyBuffs, missionEffects, xpBonus, currencyMultipliers, goldMultiplier = C_Garrison.GetPartyMissionInfo(mission.missionID)
	local baseCost, cost = C_Garrison.GetMissionCost(mission.missionID)
	local infos = mission_success[mission.missionID]
	local f 
	xp = (xp+xpBonus)
	

	-- best % -- with lowest n hero
	f = infos[1]
	if not f or ( successChance > f.successChance ) or ( successChance == f.successChance and n < f.n ) then
		save(n, combi, mission, 1, successChance, cost, xp, totalTimeSeconds, n_xp)
	end

	-- lowest cost
	f = infos[2]
	if not f or ( cost < f.cost )							or ( cost == f.cost and ( successChance > f.successChance or ( successChance == f.successChance and totalTimeSeconds < f.totalTimeSeconds ) ) ) then
		save(n, combi, mission, 2, successChance, cost, xp, totalTimeSeconds, n_xp)
	end
	
	
	-- best time
	f = infos[3]
	if not f or ( totalTimeSeconds < f.totalTimeSeconds ) 	or ( totalTimeSeconds == f.totalTimeSeconds and ( successChance > f.successChance or ( successChance == f.successChance and cost < f.cost ) ) ) then
		save(n, combi, mission, 3, successChance, cost, xp, totalTimeSeconds, n_xp)
	end	
	
	-- best xp gain
	f = infos[4]
	if not f or (xp*n_xp> f.xp*f.n_xp) or( xp*n_xp == f.xp*f.n_xp and ( cost < f.cost or (cost == f.cost and successChance > f.successChance) ) ) then
		save(n, combi, mission, 4, successChance, cost, xp, totalTimeSeconds, n_xp)
	end	
end


local function eval_me(n, combi, mission, xp)

	local requiredChampionCount = mission.requiredChampionCount
	if not requiredChampionCount then return
	end
	--print(type(requiredChampionCount))
	--C_Garrison.GetMissionInfo(missionID)
	local champion = 0
	local n_xp = 0
	for i=1, n do
		local followerID = pool_followers[combi[i]]
		if not pool_followers_troop[followerID] == true then
			champion = champion +1
		end 
		if pool_followers_xp[followerID] == true then
			n_xp = n_xp+1
		end
	end
	if champion >= requiredChampionCount then
		for i=1, n do
			local followerID = pool_followers[combi[i]]
			C_Garrison.AddFollowerToMission(mission.missionID, followerID)
		end
		rule_selection(n, combi, mission, xp, n_xp)

		
		for i=1, n do
			local followerID = pool_followers[combi[i]]
			C_Garrison.RemoveFollowerFromMission(mission.missionID, followerID)
		end
	end
end


local wt_combi = {}
function loop_me(mission)
	--local count = 0
	local pool = #pool_followers
	local set = mission.numFollowers
	local combi = wt_combi
	local xp = select(2, C_Garrison.GetMissionInfo(mission.missionID))
	
	
	
	if set >= pool then
		wipe(combi)
		for i=1, pool do
			combi[i] = i
		end
		eval_me(pool, combi, mission, xp)
		return
	end
	
	for n=1, set do
		wipe(combi)
		combi[n] = 0
		local i = n
		repeat
			combi[i] = combi[i]+1
			for j=1, i-1 do
				combi[j] = combi[i]+i-j
				--compute
			end
			eval_me(n, combi, mission, xp)

			--print(combi[1], combi[2],combi[3])
			i=0
			local value
			repeat
				i = i+1
				value = combi[i]
			until not value or value+i <= pool
	--count = count+1
		until i>n
	end
	--print(count)
end


--env.compare_table(GetPoolFollowers(wt), pool_followers)

local wt = {}
function env.update_pool_followers()
	if not pool_followers_updated  then
		if not compare_table(GetPoolFollowers(wt), pool_followers) then
			--wipe(pool_followers)

			for i=1, #wt do
				--table.insert(pool_followers, wt[i]
			end
			GetPoolFollowers(pool_followers, 1)
			wipe(mission_success)
		else
		end
	end
end

globalupdate_pool_followers = env.update_pool_followers
local function Unregisterevent_GARRISON_FOLLOWER_LIST_UPDATE(wt,...)
	if not next(wt) then
		local n = select("#", ...)
		wt[0] = n
		for i=1, n do
			local frame = select(i,...)
			frame:UnregisterEvent("GARRISON_FOLLOWER_LIST_UPDATE")
			wt[i] = frame
		end
	end
end

env.find_followers = function (wt, mission)
	mission_success[mission.missionID] = {}
	if #pool_followers > 0 then
		Unregisterevent_GARRISON_FOLLOWER_LIST_UPDATE(wt, GetFramesRegisteredForEvent("GARRISON_FOLLOWER_LIST_UPDATE"))
		loop_me(mission)
	end
end



--[[	self:RegisterEvent("GARRISON_FOLLOWER_LIST_UPDATE");
	self:RegisterEvent("GARRISON_FOLLOWER_REMOVED");
	self:RegisterEvent("GARRISON_FOLLOWER_XP_CHANGED");
	self:RegisterEvent("GARRISON_FOLLOWER_UPGRADED");
	self:RegisterEvent("GARRISON_FOLLOWER_DURABILITY_CHANGED");
	self:RegisterEvent("CURRENT_SPELL_CAST_CHANGED");
	]]

